<?php

if (!defined('TOBBIVM'))
   header('location:/template/notrepassing.php');
/**
 * This file is part of TobbiVMShop.
 *
 * TobbiVMShop is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TobbiVMShop is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TobbiVMShop.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * create category editor page
 * get: category.browse.tpl.php
 * used from category.page.php
 *
 * @version    $Id: category.page.editor.php 30 2018-08-13 11:08:47Z norbert-neo $
 * @package    TobbiVM-Shop
 * @copyright  Copyright (C) 2012
 * @author     Norbert Gebert
 * @license    GPL3
 */
$idy = $refValidate->cleanslash($_GET['id']);
db::getInstance()->where("category_id", $idy);
$result = db::getInstance()->getOne("category");

if ($result === NULL)
{ // if error...
   message::setErrorRow(_('Databaseerror in Table CATEGORY - Contact the Admin!'), true);
} else
{
   $refPage->assign('page_title', _('Product Category Editor'));
   $refPage->assign('textHelp', help('categoryText', $page, TRUE));

   $refPage->assign('id', _('Category-ID') . ': ');
   $refPage->assign('idx', '<input type="text" name="idx" id="idx" disabled="disabled" ' .
           'size="8" value="' . $result['category_id'] . '"/>');

   $refPage->assign('name', _('Name') . ': ');
   $refPage->assign('namex', $result['category_name']);
   $refPage->assign('namexHelp', help('categoryName', $page));

   // set active-status for all shops
   $refPage->assign('active', strip_tags(_('Activ') . ': '));
   $refPage->assign('active_0', strip_tags(SHORTNAME));
   $activey = '<input type="checkbox" name="activex" id="activex" value="activex" ';

   if ($result['category_active'] === '0')
      $activey .= '/>';
   else
      $activey .= 'checked />';

   $refPage->assign('activex_0', $activey);
   $refPage->assign('text', _('Description'));
   $refPage->assign('categoryActiveHelp', help('categoryActive', $page));

   if (URL_1 <> '')
   {
      $refPage->assign('active_1', strip_tags(SHORTNAME_1));
      $activey = '<input type="checkbox" name="activex_1" id="activex_1" value="activex_1" ';

      if ($result['category_active_1'] === '0')
         $activey .= '/>';
      else
         $activey .= 'checked />';

      $refPage->assign('activex_1', $activey);
   }

   if (URL_2 <> '')
   {
      $refPage->assign('active_2', strip_tags(SHORTNAME_2));
      $activey = '<input type="checkbox" name="activex_2" id="activex_2" value="activex_2" ';

      if ($result['category_active_2'] === '0')
         $activey .= '/>';
      else
         $activey .= 'checked />';

      $refPage->assign('activex_2', $activey);
   }

   if (URL_3 <> '')
   {
      $refPage->assign('active_3', strip_tags(SHORTNAME_3));
      $activey = '<input type="checkbox" name="activex_3" id="activex_3" value="activex_3" ';

      if ($result['category_active_3'] === '0')
         $activey .= '/>';
      else
         $activey .= 'checked />';

      $refPage->assign('activex_3', $activey);
   }

   if (URL_4 <> '')
   {
      $refPage->assign('active_4', strip_tags(SHORTNAME_4));
      $activey = '<input type="checkbox" name="activex_4" id="activex_4" value="activex_4" ';

      if ($result['category_active_4'] === '0')
         $activey .= '/>';
      else
         $activey .= 'checked />';

      $refPage->assign('activex_4', $activey);
   }
   if (URL_5 <> '')
   {
      $refPage->assign('active_5', strip_tags(SHORTNAME_5));
      $activey = '<input type="checkbox" name="activex_5" id="activex_5" value="activex_5" ';

      if ($result['category_active_5'] === '0')
         $activey .= '/>';
      else
         $activey .= 'checked />';

      $refPage->assign('activex_5', $activey);
   }

   $refPage->assign('descriptionx', $result['category_description']);

   // image
   $refPage->assign('image', _('Big image') . ': ');
   $refPage->assign('imagex', '<input type="file" size="55" name="uploadfile" id="uploadfile" />');
   $refPage->assign('imagexHelp', help('categoryBigImage', $page));

   $file = '../images/' . CATEGORY_IMAGE_PATH . '/' . $result['category_id'] . '/' .
           $result['category_image'];

   if (is_file($file))
   {
      $refPage->assign('imageName', $result['category_image']);
      $image = getimagesize($file);
      $refPage->assign('imageNote', _('Width') . ': ' . $image[0] . 'px, ' .
              _('Height') . ': ' . $image[1] . 'px = ' . 
              filesize($file) . 'Byte  (' . _('Max.:') . 
              ini_get('upload_max_filesize') . ')');

      $refPage->assign('imagey', '<img style="border:1px solid black;" src="../images/' . CATEGORY_IMAGE_PATH . '/' .
              $result['category_id'] . '/' . $result['category_image'] . '">');
   } else
   {
      $refPage->assign('imageName', ' ');
      $refPage->assign('imageNote', _(' '));
      $refPage->assign('imagey', _('<h2>No picture available!</h2>'));
   }

   $refPage->assign('imageAlt', _('Alt-Attribute') . ': ');
   $refPage->assign('imageAltx', $result['category_image_alt']);
   $refPage->assign('imageAltxHelp', help('alternate', $page));
   $refPage->assign('imageTitle', _('Title-Attribute') . ': ');
   $refPage->assign('imageTitlex', $result['category_image_title']);
   $refPage->assign('imageTitlexHelp', help('title', $page));


   // small-image
   $refPage->assign('thumbImage', _('Small image') . ': ');
   $refPage->assign('thumbImagex', '<input type="file" class="ngggg" size="55" name="smallUploadfile" id="smallUploadfile" />');
   $refPage->assign('thumbImageyHelp', help('categoryThumbImage', $page));

   $file = '../images/' . CATEGORY_IMAGE_PATH . '/' . $result['category_id'] . '/' .
           CATEGORY_IMAGE_THUMB_PATH . '/' . $result['category_small_image'];

   if (is_file($file))
   {
      $image = getimagesize($file);
      $refPage->assign('thumbImageName', $result['category_small_image']);
      $refPage->assign('thumbImageNote', _('Width') . ': ' . $image[0] . 'px, ' .
              _('Height') . ': ' . $image[1] . 'px = ' . 
              filesize($file) . 'Byte  (' . _('Max.:') . 
              ini_get('upload_max_filesize') . ')');
      $refPage->assign('thumbImagey', '<img style="border:1px solid black;" src="../images/' . CATEGORY_IMAGE_PATH . '/' .
              $result['category_id'] . '/' . CATEGORY_IMAGE_THUMB_PATH . '/' .
              $result['category_small_image'] . '">');
   } else
   {
      $refPage->assign('thumbImageName', ' ');
      $refPage->assign('thumbImageNote', _(' '));
      $refPage->assign('thumbImagey', _('<h2>No picture available!</h2>'));
   }

   $refPage->assign('thumbImageAlt', _('Alt-Attribute') . ': ');
   $refPage->assign('thumbImageAltx', $result['category_small_image_alt']);
   $refPage->assign('imageAltxHelp', help('alternate', $page));
   $refPage->assign('thumbImageTitle', _('Title-Attribute') . ': ');
   $refPage->assign('thumbImageTitlex', $result['category_small_image_title']);
   $refPage->assign('imageTitlexHelp', help('title', $page));

   // read and set article-browsepages  selected="selected"
   $browsepages = array();
   foreach (getBrowsepages('category') as $file)
   {
      if ($file === $result['category_browsepage'])
      {
         $browsepages[] = array('browsepage_nrx' => $file,
             'browsepage_textx' => $file,
             'checkedx' => 'selected="selected"');
      } else
      {
         $browsepages[] = array('browsepage_nrx' => $file,
             'browsepage_textx' => $file,
             'checkedx' => '');
      }
   }
   $refPage->assign('browsepages', $browsepages);
   $refPage->assign('browsepage', _('Browsepage') . ': ');
   $refPage->assign('browsepagexHelp', help('categoryBrowsepage', $page));

   // read and set categorynames
   $categorys = db::getInstance()->rawQuery("SELECT category_id, category_name, category_active, " .
           "category_order, category_top FROM category WHERE category_top = '0'" .
           " ORDER BY category_order");

   $categorys = sortCategorys($categorys, false);
   $categoryTops = array();
   if ($result['category_top'] === '0')
   {
      $categoryTops[] = array('top_nrx' => '0',
          'top_textx' => _('Top-category'),
          'checkedx' => 'selected="selected"');
   } else
   {
      $categoryTops[] = array('top_nrx' => '0',
          'top_textx' => _('Top-category'),
          'checkedx' => '');
   }
   foreach ($categorys as $cat)
   {
      if ($cat['category_id'] === $result['category_top'])
      {
         $categoryTops[] = array('top_nrx' => $cat['category_id'],
             'top_textx' => $cat['category_name'],
             'checkedx' => 'selected="selected"');
      } else
      {
         $categoryTops[] = array('top_nrx' => $cat['category_id'],
             'top_textx' => $cat['category_name'],
             'checkedx' => '');
      }
   }
   $refPage->assign('categoryTops', $categoryTops);
   $refPage->assign('categoryTop', _('Top-Category') . ': ');
   $refPage->assign('categoryTopxHelp', help('categoryCategory', $page));

   $refPage->assign('toshow', _('Display Products') . ': ');
   $refPage->assign('toshowx', $result['category_display_products']);
   $refPage->assign('toShowxHelp', help('categoryToShow', $page));

   $refPage->assign('title', _('Title') . ': ');
   $refPage->assign('titleNo', 'onmouseover="titleN(this.value)" onkeyup="titleN(this.value)"');
   $refPage->assign('titlex', $result['category_title']);
   $refPage->assign('titlexHelp', help('categoryTitle', $page));

   $refPage->assign('metadescription', _('Metadescrip.') . ': ');
   $refPage->assign('metadescriptionNo', 'onmouseover="descriptionN(this.value)" onkeyup="descriptionN(this.value)"');
   $refPage->assign('metadescriptionx', $result['category_metadescription']);
   $refPage->assign('metadescriptionxHelp', help('categoryMetadescription', $page));

   $refPage->assign('create', _('Created') . ': ');
   $refPage->assign('createx', '<input type="text" name="createx" id="createx" ' .
           'disabled="disabled" value="' .
           date('H:i:s - d.m.Y', strtotime($result['category_create'])) . '"/>');

   $refPage->assign('lastchange', _('Last change') . ': ');
   $refPage->assign('lastchangex', '<input type="text" name="lastchangex" id="lastchangex" ' .
           'disabled="disabled" value="' .
           date('H:i:s - d.m.Y', strtotime($result['category_last_change'])) . '"/>' .
           '<input type="hidden" name="idx" value="' . $result['category_id'] . '">' .
           '<input type="hidden" name="orderx" value="' . $result['category_order'] . '">' .
           '<input type="hidden" name="oldImagex" value="' . $result['category_image'] . '">' .
           '<input type="hidden" name="oldSmallImagex" value="' . $result['category_small_image'] . '">' .
           '<input type="hidden" name="oldtopx" value="' . $result['category_top'] . '">');

   $refPage->assign('btnRefresh', '<input type="submit" name="submit" id="refresh" value="' .
           _('Refresh') . '" />');
   $refPage->assign('btnSave', '<input type="submit" name="submit" id="save" value="' .
           _('Save') . '" />');
   $refPage->assign('btnAbort', '<input type="submit" name="submit" id="abort" value="' .
           _('Abort') . '">');

   $refPage->assign('Form_Start', '<form action="' . 'index2.php?page=article&sub=category&id=' .
           $result['category_id'] . '&func=save#' . $idy .
           '" method="post" class="niceform fieldset" ' .
           'enctype="multipart/form-data"><fieldset>');
   $refPage->addtpl('content', '/' . $page . '/' . $subpage . '.editor.tpl.php');
   $refPage->assign('messagebox', '');
   $refPage->assign('Form_End', '</fieldset></form>');


   // Keyword- and descriptioncounter
   $refPage->assign('descriptionNumber', '<span id="descriptionNumber">0</span>');
   $refPage->assign('keywordNumber', '<span id="keywordNumber">0</span>');
   $refPage->assign('titleNumber', '<span id="titleNumber">0</span>');

   $metascript = '<script type="text/javascript">
		function descriptionN(text) 
		{
			var html = text.length;
			html = html + "   ' . _('Character') . ' (' . METADESCRIPTION_LENGH . ')";
			document.getElementById(\'descriptionNumber\').textContent = html;
		}
		function keywordN(text) 
		{
			var html = text.split(\',\').length;
			html = html + "   ' . _('Words') . ' (' . METAKEYWORD_NUMBER . ')";
			document.getElementById(\'keywordNumber\').textContent = html;
		}
		function titleN(text) 
		{
			var html = text.length;
			html = html + "   ' . _('Character') . ' (70)";
			document.getElementById(\'titleNumber\').textContent = html;
		}
	</script>';

   $refPage->assign('scripts', '<script type="text/javascript" src="' .
           'module/ckeditor/ckeditor.js"></script>' . $metascript);
}
