<?php

if (!defined('TOBBIVM'))
   header('location:/template/notrepassing.php');
/**
 * This file is part of TobbiVMShop.
 *
 * TobbiVMShop is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TobbiVMShop is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TobbiVMShop.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * create parts of the category menu
 * used from core.php
 * use topmenu.tpl.php
 * 
 * @since 0.0.2
 * @version 0.1.3
 * @package TobbiVM-Shop
 * @copyright Copyright (C) 2012
 * @license    GPL3
 * @category frontend
 * @package menu
 * @subpackage template
 * $Rev: 43 $
 * $Date: 2018-09-18 12:22:39 +0200 (Di, 18. Sep 2018) $
 * $Author: norbert-neo $
 * $URL: https://svn.code.sf.net/p/tobbivm/code/trunk/module/menu/categorypage.menu.php $
 */

/**
 * Generate Output for categorymenue
 * @param object $refPage reference to Template-Class
 * @param keyword $page pageart to display
 * @param string $title id-value
 * @return void
 */
function categoryMenu($refPage, $page, $title) {
   $refPage->assign('categoryList', _('Productlist'));

   db::getInstance()->orderBy('category_order', 'ASC');
   db::getInstance()->where('category_active' . SUFFIX, '1');
   db::getInstance()->where('category_top', 0);
   $cols = Array('category_id', 'category_name', 'category_order', 'category_top');
   $result = db::getInstance()->get("category", null, $cols);

   $buffer = sortCategorys($result, true);
   $categoryList = array();

   $dataId = ['product_category'];
   db::getInstance()->where('product_active' . SUFFIX, 1);
   db::getInstance()->where('product_id', filter::valGetInt('xtitle'));
   $resultId = db::getInstance()->getone('product', null, $dataId);
   $_SESSION['categoryMenux'] = $resultId['product_category'];

   foreach ($buffer as $entry)
   {
      if ($page == 'article' and $entry['category_id'] == $_SESSION['categoryMenux'])
      {
         $classname = 'mainlevel-active';
      }
      elseif ($page == 'category' and $title == $entry['category_id'])
      {
         $classname = 'mainlevel-active';
         $_SESSION['categoryMenux'] = $entry['category_id'];
      }
      else
      {
         $classname = 'mainlevel';
      }
      $categoryList[] = array(
          'categoryTitle' => $entry['category_name'],
          'categoryClass' => $classname,
          'categoryHref' => '/index.php?page=category&amp;xtitle=' . $entry['category_id'] .
          '&amp;name=' . seo::getSeoString($entry['category_name']),
          'categoryName' => $entry['category_name']);
   }
   $refPage->assign('categoryMenu', $categoryList);
}
